import React from 'react';
import ReactDom from 'react-dom';
import ajax from 'jquery/src/ajax/xhr.js';
import $ from 'jquery/src/ajax';
import { Form,Radio, Icon, Button, Input, Select, Spin, Table, Switch, message, DatePicker, Modal, Upload } from 'antd';
import Newuser from "./newUser.jsx"
import './userMangagement.less'
import {techAuditStatusList, station,post } from '../../../dataDic.js';

const User=Form.create()(React.createClass({
	loadData(pageNo) {
        this.state.data = [];
        this.setState({
            loading: true
        });
        $.ajax({
            method: "get",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + '/api/admin/supervise/adminLi',
            data: {
                pageNo: pageNo || 1,
                pageSize: this.state.pagination.pageSize,
                userName:this.state.userNameSearch,
				organization:this.state.organizationSearch,
				role:this.state.rolesSearch,
				post:this.state.postSearch,
				station:this.state.stationSearch,
				status:this.state.statusSeach,
				signName:this.state.signNameSearch,
				mobile:this.state.mobileSearch,
				proName:this.state.proNameSearch
            },
            success: function (data) {
                let theArr = [];
                if (!data.data || !data.data.list) {
                    if (data.error && data.error.length) {
                        message.warning(data.error[0].message);
                    };
                } else {
                    for (let i = 0; i < data.data.list.length; i++) {
                        let thisdata = data.data.list[i];
                        theArr.push({
                            key: i,
                            id: thisdata.id,
                            mobile: thisdata.mobile,
                            name: thisdata.name,
                            email: thisdata.email,
                            createTime: thisdata.createTime,
                            number: thisdata.number,
                            province: thisdata.province,
                            position: thisdata.position,
                            superior: thisdata.superior,
                            superiorId: thisdata.superiorId,
                            createTimeFormattedDate: thisdata.createTimeFormattedDate
                        });
                    };   
                };
                this.state.pagination.current = data.data.pageNo?data.data.pageNo:'0';
                this.state.pagination.total = data.data.totalCount?data.data.totalCount:'0';
                this.setState({
                    dataSource: theArr,
                    pagination: this.state.pagination
                });
            }.bind(this),
        }).always(function () {
            this.setState({
                loading: false
            });
        }.bind(this));
    },
    getInitialState() {
        return {
        	datauser:{},
            searchMore: true,
            selectedRowKeys: [],
            selectedRows: [],
            loading: false,
            pagination: {
                defaultCurrent: 1,
                defaultPageSize: 10,
                showQuickJumper: true,
                pageSize: 10,
                onChange: function (page) {
                    this.loadData(page);
                }.bind(this),
                showTotal: function (total) {
                    return '共' + total + '条数据';
                }
            },
            columns: [
                {
                    title: '用户编号',
                    dataIndex: 'key',
                    key: 'key',
                }, {
                    title: '登录用户名',
                    dataIndex: 'name',
                    key: 'name',
                }, {
                    title: '角色',
                    dataIndex: 'email',
                    key: 'email',
                }, {
                    title: '用户姓名',
                    dataIndex: 'createTime',
                    key: 'createTime',
                }, {
                    title: '组织机构',
                    dataIndex: 'number',
                    key: 'number',
                }, {
                    title: '职务',
                    dataIndex: 'auditStatus',
                    key: 'auditStatus',
                }, 
                {
                    title: '岗位',
                    dataIndex: 'boutique',
                    key: 'boutique',
                },
                 {
                    title: '联系手机',
                    dataIndex: 'mobile',
                    key: 'mobile',
                },
                {
                    title: '上级主管姓名',
                    dataIndex: 'province',
                    key: 'province',
                },
                {
                    title: '状态',
                    dataIndex: 'a',
                    key: 'a',
                }
            ],
            dataSource: [],
        };
    },
    componentWillMount() {
        let organizationArr = [];
        techAuditStatusList.map(function (item) {
            organizationArr.push(
                <Select.Option value={item.value} key={item.key}>{item.key}</Select.Option>
            )
        });
        this.state.organizationList = organizationArr;
        this.loadData();
    },
    tableRowClick(record, index) {
    	this.state.userDetaile=true;
        this.state.datauser = record;
        this.setState({
            showDesc: true
        });
    },
    //锁定
    locking() {
        let deletedIds = [];
        for (let idx = 0; idx < this.state.selectedRows.length; idx++) {
            let rowItem = this.state.selectedRows[idx];
            if (rowItem.id) {
                deletedIds.push(rowItem.id)
            };
        };
        this.setState({
            selectedRowKeys: [],
            loading: true
        });
        $.ajax({
            method: "POST",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + "/api/admin/achievement/delete",
            data: {
                ids: deletedIds
            }
        }).done(function (data) {
            if (!data.error.length) {
                message.success('锁定成功！');
                this.setState({
                    loading: false,
                });
            } else {
                message.warning(data.error[0].message);
            };
            this.loadData();
        }.bind(this));
    },
    //激活
    activation() {
        let deletedIds = [];
        for (let idx = 0; idx < this.state.selectedRows.length; idx++) {
            let rowItem = this.state.selectedRows[idx];
            if (rowItem.id) {
                deletedIds.push(rowItem.id)
            };
        };
        this.setState({
            selectedRowKeys: [],
            loading: true
        });
        $.ajax({
            method: "POST",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + "/api/admin/achievement/delete",
            data: {
                ids: deletedIds
            }
        }).done(function (data) {
            if (!data.error.length) {
                message.success('激活成功！');
                this.setState({
                    loading: false,
                });
            } else {
                message.warning(data.error[0].message);
            };
            this.loadData();
        }.bind(this));
    },
    //删除
    delectRow() {
        let deletedIds = [];
        for (let idx = 0; idx < this.state.selectedRows.length; idx++) {
            let rowItem = this.state.selectedRows[idx];
            if (rowItem.id) {
                deletedIds.push(rowItem.id)
            };
        };
        this.setState({
            selectedRowKeys: [],
            loading: true
        });
        $.ajax({
            method: "POST",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + "/api/admin/achievement/delete",
            data: {
                ids: deletedIds
            }
        }).done(function (data) {
            if (!data.error.length) {
                message.success('删除成功！');
                this.setState({
                    loading: false,
                });
            } else {
                message.warning(data.error[0].message);
            };
            this.loadData();
        }.bind(this));
    },
    addClick() {
    	this.state.userDetaile=false;
        this.setState({
            showDesc: true
        });
    },
    closeDesc(e, s) {
        this.state.showDesc = e;
        if (s) {
            this.loadData();
        };
    },
    search() {
        this.loadData();
    },
    reset() {
    	this.state.userNameSearch='';
		this.state.organizationSearch=undefined;
		this.state.rolesSearch=undefined;
		this.state.postSearch=undefined;
		this.state.stationSearch=undefined;
		this.state.statusSeach=undefined;
		this.state.signNameSearch='';
		this.state.mobileSearch='';
		this.state.proNameSearch='';
        this.loadData();       
    },
    searchSwitch() {
        this.setState({
            searchMore: !this.state.searchMore
        });
    },
    render() {
        const rowSelection = {
            selectedRowKeys: this.state.selectedRowKeys,
            onChange: (selectedRowKeys, selectedRows) => {
            	if(selectedRows.length=='10'){
                	this.setState({
                    selectedRows: [],
                    selectedRowKeys: ''
                });
                }else{
	                this.setState({
	                    selectedRows: selectedRows.slice(-1),
	                    selectedRowKeys: selectedRowKeys.slice(-1)
	                });
                }
                
            }
        };
        const hasSelected = this.state.selectedRowKeys.length > 0;
        const { RangePicker } = DatePicker;
        return (
            <div className="user-content" >
                <div className="content-title">
	                <div className="user-search">
	                    <Input placeholder="用户姓名" style={{width:'150px'}}
	                        value={this.state.userNameSearch}
	                        onChange={(e) => { this.setState({ userNameSearch: e.target.value }); }} />
	                    <Select placeholder="组织机构"
                            style={{ width: 160 }}
                            value={this.state.organizationSearch}
                            onChange={(e) => { this.setState({ organizationSearch: e }) }}>
                            {this.state.organizationList}
                        </Select>
                        <Select placeholder="角色"
                            style={{ width: 160 }}
                            value={this.state.rolesSearch}
                            onChange={(e) => { this.setState({ rolesSearch: e }) }}>
                            {this.state.organizationList}
                        </Select>    
	                    <Button type="primary" onClick={this.search}>搜索</Button>
	                    <Button onClick={this.reset}>重置</Button>
	                    <Button style={{ background: "red", border: "none", color: "#fff" }}
	                        disabled={!hasSelected}
	                        onClick={this.delectRow}>删除<Icon type="minus" /></Button>
	                    <Button style={{ background: "#333333", border: "none", color: "#fff" }}
	                        disabled={!hasSelected}
	                        onClick={this.locking}>锁定<Icon type="lock" /></Button>
	                    <Button style={{ background: "green", border: "none", color: "#fff" }}
	                        disabled={!hasSelected}
	                        onClick={this.activation}>激活<Icon type="unlock" /></Button>
	                    
	                    <span>更多搜索<Switch defaultChecked={false} onChange={this.searchSwitch} /></span>
	                    <Button type="primary" className="addButton" onClick={this.addClick} disabled>新增用户<Icon type="user" /></Button>
	                    <div className="search-more" style={this.state.searchMore ? { display: 'none' } : {}}>
	                    	<Select placeholder="职务"
	                            style={{ width: 160 }}
	                            value={this.state.postSearch}
	                            onChange={(e) => { this.setState({ postSearch: e }) }}>
	                            {
                                    post.map(function (item) {
                                        return <Select.Option key={item.value} >{item.key}</Select.Option>
                                    })
                                }
                            </Select>
                            <Select placeholder="岗位"
	                            style={{ width: 160 }}
	                            value={this.state.stationSearch}
	                            onChange={(e) => { this.setState({ stationSearch: e }) }}>
	                             {
                                    station.map(function (item) {
                                        return <Select.Option key={item.value} >{item.key}</Select.Option>
                                    })
                                }
                       		</Select>
                       		<Select placeholder="状态"
	                            style={{ width: 160 }}
	                            value={this.state.statusSeach}
	                            onChange={(e) => { this.setState({ statusSeach: e }) }}>
	                            {this.state.organizationList}
                       		</Select>
                       		<Input placeholder="登录用户名" style={{width:'150px'}}
		                        value={this.state.signNameSearch}
		                        onChange={(e) => { this.setState({ signNameSearch: e.target.value }); }} />
	                        <Input placeholder="联系手机" style={{width:'150px',margin:'0 15px'}}
		                        value={this.state.mobileSearch}
		                        onChange={(e) => { this.setState({ mobileSearch: e.target.value }); }} />
	                        <Input placeholder="上级主管名称" style={{width:'150px'}}
		                        value={this.state.proNameSearch}
		                        onChange={(e) => { this.setState({ proNameSearch: e.target.value }); }} />
	                    </div>
	                </div>
	                <div className="patent-table">
	                    <Spin spinning={this.state.loading}>
	                        <Table columns={this.state.columns}
	                            dataSource={this.state.dataSource}
	                            rowSelection={rowSelection}
	                            pagination={this.state.pagination}
	                            onRowClick={this.tableRowClick} />
	                    </Spin>
	                </div>
	                <Newuser
	                    userDetaile={this.state.userDetaile}
	                    datauser={this.state.datauser}
	                    showDesc={this.state.showDesc}
	                    closeDesc={this.closeDesc} />
	            </div >
            </div>
        );
    }
}));

export default User;
